import os
from binascii import hexlify
from copy import copy
from rugged.lib.logger import get_logger, log_exception
from securesystemslib.formats import encode_canonical
from securesystemslib.keys import verify_signature
from tuf.api.exceptions import UnsignedMetadataError
from typing import Any, Dict

log = get_logger()


def load_signature(key_type: str, keyid: str, path_to_signature: str) -> Dict[str, Any]:
    """ Load a signature from disk, and return it in the TUF format. """

    # @TODO: Use match statement once we move to Python 3.10.
    # @TODO: Also, move to Python 3.10.
    if key_type == 'tuf':
        signature = _load_tuf_signature(path_to_signature)
    elif key_type == 'pem':
        signature = _load_pem_signature(path_to_signature)
    else:
        log.error(f"The '{key_type}' key type is not supported.")
        sys.exit(os.EX_USAGE)

    return {
        'keyid': keyid,
        'sig': signature
    }

def verify_signature_is_valid_for_key(key_orig: Dict, signature: Dict, message: Dict) -> bool:
    """Verify the provided signature is valid for the signed metadata and produced by a given key."""

    keyid = signature['keyid']

    # Do not alter the original key since it's a reference to the key in the message
    key = copy(key_orig)
    key['keyid'] = keyid
    try:
        canonical_bytes = encode_canonical(message).encode("utf-8")
        if verify_signature(key, signature, canonical_bytes):
            log.debug(f"Signature verified for key {keyid}")
            return True
        else:
            log.error(f"Signature NOT verified for key {keyid}")
            return False
    except Exception as e:
        log_exception(e)
        message = f"Error verifying signature was generated by {keyid}."
        log.error(message)
        return False

def _load_tuf_signature(path_to_signature: str) -> str:
    """ Load a TUF signature. """

    log.debug(f"Loading signature from file: {path_to_signature}")
    with open(path_to_signature, "r") as signature_file:
        signature = signature_file.read().strip()
    log.debug(f"Loaded signature from file: {path_to_signature}")
    return signature


def _load_pem_signature(path_to_signature: str) -> str:
    """ Load a PEM signature. """

    log.debug(f"Loading signature from file: {path_to_signature}")
    with open(path_to_signature, "rb") as signature_file:
        signature = signature_file.read()
    log.debug(f"Loaded signature from file: {path_to_signature}")
    return (hexlify(signature).decode('utf-8'))
